/* $Id: winpubd.c,v 1.4 1998/03/29 09:50:40 root Exp $
 * Veghead 1998 
 * Inspired by the sharp minds at Direct Connection
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>
#include <errno.h>
#include <time.h>

#define PORTNUM 99
#define CLISIZE 50 
#define STALETIME 120 

void leave(char *message);

struct client {
   char			status;
   struct sockaddr_in cliaddr;
   time_t		t;
};

int debug=0;

main(int argc,char**argv)
{
int sock;
struct protoent *pe;
struct sockaddr_in addr,raddr;
int got2,got,fd,res,portnum=PORTNUM,
    daemon=1;
char ib[512];
struct client clidb[CLISIZE];

argv++;
while (argc>1) {
   switch(**argv) {
       case('-'):
     switch((*argv)[1]) {
         case('i'):daemon=0;break;
         case('d'):debug++;break;
         case('p'):if (argc>2) {argv++;argc--;portnum=atoi(*argv);}break;
           default:usage();
         }
      break;
       default:usage();
       }
  argv++;
  argc--;
  }

if (debug) printf("Local port:%d\n",portnum);

if (daemon) {
   if ((fd=open("/dev/tty",O_RDONLY|O_NOCTTY))!=-1) {
      ioctl(fd,TIOCNOTTY);
      }
   if (fork()!=0) {
      exit(0);
      }
}
pe=getprotobyname("UDP");
if ((sock=socket(AF_INET,SOCK_DGRAM,pe->p_proto))==-1) {
   leave("unable to create socket");
   }
addr.sin_family=AF_INET;
addr.sin_port=htons(portnum);
addr.sin_addr.s_addr=htons(INADDR_ANY);
if (res=bind(sock,(struct sockaddr *)&addr,sizeof(addr))==-1) {
   leave("bind");
  }
got2=sizeof(raddr);
while (1) {
   if ((got=recvfrom(sock,&ib,512,0,(struct sockaddr *)&raddr,&got2))!=-1) {
     switch (ib[0]) {
        case ('I') :addclient(&raddr,clidb);break;
        case ('P') :pubsend(sock,&ib,got,clidb);break;
        default    :if (debug) puts("Fish");break;
        }
     }
   }
}


void
leave(char *out)
{
perror(out);
exit(1);
}



addclient(struct sockaddr_in *ad, struct client *clidb)
{
int i=0,ok=0,added=-1;
time_t timenow;
timenow=time(NULL);
for (i=0;i<CLISIZE;i++) {
   if ((debug)&&(clidb[i].status=='1')) {
      printf("%s %d\n",inet_ntoa(clidb[i].cliaddr.sin_addr),i);
      }
   if (clidb[i].status!='1') {
     added=i;
     } 
   else if ((timenow-clidb[i].t) >STALETIME) {
      clidb[i].status='0';
      added=i;
      if (debug) printf("Timeout %d %d %d\n",i,timenow,clidb[i].t);
      }
   else if (memcmp(&clidb[i].cliaddr.sin_addr,&ad->sin_addr,sizeof(clidb[i].cliaddr.sin_addr))==0) {
      ok=1;
      clidb[i].t=timenow;
      clidb[i].cliaddr.sin_port=ad->sin_port;
      added=i;
      if (debug) printf("Already found at %d - %d - Port:%d\n",i,
                        sizeof(clidb[i].cliaddr),clidb[i].cliaddr.sin_port);
      } 
   }
if ((!ok)&&(added>-1)) {
   clidb[added].status='1';
   clidb[added].t=timenow;
   memcpy(&clidb[added].cliaddr,ad,sizeof(clidb[added].cliaddr));
   if (debug) printf("Added %d - %d\n",added,sizeof(clidb[added].cliaddr));
   }
if (debug) printf("%s is here! %d \n",inet_ntoa(clidb[added].cliaddr.sin_addr),timenow);
}




pubsend(int sock,char *msg,int size,struct client *clidb)
{
int i,res;
time_t timenow;
timenow=time(NULL);

msg[0]='B';
for (i=0;i<CLISIZE;i++) {
   if (clidb[i].status=='1') {
     if ((timenow-clidb[i].t) >STALETIME) {
        clidb[i].status='0';
        if (debug) printf("Timeout %d %d %d\n",i,timenow,clidb[i].t);
        }
     else {
        res=sendto(sock,msg,size,0,(struct sockaddr *)&clidb[i].cliaddr,
                                                  sizeof(clidb[i].cliaddr));
        if (debug) {
             printf("Send res:%d to %s\n",res,inet_ntoa(clidb[i].cliaddr.sin_addr));
             }
        }
    }
   } 
}


usage()
{
printf("winpubd [-p port]\n");
}

